#include <Stepper.h> // Programmbibliothek.
const int SPDrehung = 400; //Schritte / Umdrehung, maximum bei 400
Stepper stepperWaagerecht(SPDrehung, 6, 7);
Stepper stepperSenkrecht (SPDrehung, 4, 5);
Stepper stepperRotation (SPDrehung, 2, 3);
int TRIG_PIN = 13;
int ECHO_PIN = A1;
float wert_x = 0;
float wert_y = 0;
float durchschnitt_x;
float durchschnitt_z;


void setup() {
  float yWert;
  pinMode (2, OUTPUT);
  pinMode (3, OUTPUT);
  pinMode (4, OUTPUT);
  pinMode (5, OUTPUT);
  pinMode (6, OUTPUT);
  pinMode (7, OUTPUT);
  pinMode(TRIG_PIN, OUTPUT); //Trigger Pin ist ausgang

  pinMode(ECHO_PIN, INPUT);// Echo pin ist eingang
  Serial.begin(9600);

  float summeX = 0;
  int counterX = 0;
  //werte für x

  for ( int x = 0; x <= 1536; x = x + 60) { //sensor bewegt sich nach rechts

    //Bewegen
    stepperWaagerecht.setSpeed(250); // Geschwindigkeit in Umdrehungen/Minute
    stepperWaagerecht.step(-196); //

    //Messung aufnehmen
    digitalWrite(TRIG_PIN, LOW);//Spannung nimmt kurz ab beim senden d. Trigger-Signals -> rauschfreies Signal
    delayMicroseconds(2);
    digitalWrite(TRIG_PIN, HIGH);//Utraschallwelle schicken
    delayMicroseconds(10);       //für 10 Mikrosekunden pausieren
    digitalWrite(TRIG_PIN, LOW); // Schall abschalten
    long dauer = pulseIn(ECHO_PIN, HIGH); //zählt die Zeit, wie lange der Ultraschall braucht, bis er wieder zurückkommt
    float entfernung;
    entfernung = dauer / 29.00 / 2.00; //Entfernung in Zentimetern: Zeit/2 (Weil man ja nur eine Strecke berechnen möchte
    //und nicht die Strecke hin- und zurück). Den Wert multipliziert man mit der Schallgeschwindigkeit in Zentimeter/
    //Mikrosekunde und erhält Wert in Zentimetern.

    if (entfernung <= 20) {
      // Serial.println(entfernung);
      summeX = summeX + entfernung;
      counterX++;
    }


    //delay(1000);
  }
  float durchschnitt_x = summeX / counterX;
  Serial.println ("EntfernungX");
  Serial.println (durchschnitt_x);
  // Die Kreisplatte wird bewegt, damit Messwerte für Z-Koordinate aufgenommen werden können
  stepperRotation.setSpeed(200);
  stepperRotation.step(-2400); // Kreisfläche soll sich um 90 grad im Uhrzeigersinn drehen(, weil es sonst wegen dem Band hackt)

  float summeZ = 0;
  int counterZ = 0;
  //werte für z

  for (int z = 0; z <= 1536 ; z = z + 60) {
    //Bewegen
    stepperWaagerecht.setSpeed(250);
    stepperWaagerecht.step(196); //Sensor nach rechts bewegen


    //Messung aufnehmen
    digitalWrite(TRIG_PIN, LOW);
    delayMicroseconds(2);
    digitalWrite(TRIG_PIN, HIGH);
    delayMicroseconds(10);
    digitalWrite(TRIG_PIN, LOW);
    long dauer = pulseIn(ECHO_PIN, HIGH);
    float entfernung;
    entfernung = dauer / 29.00 / 2.00;
    //float varEntfernung;
    //varEntfernung = Messung(1);


    if (entfernung <= 20) {
      // Serial.println(entfernung);
      summeZ = summeZ + entfernung;
      counterZ++;
    }

  }
  float durchschnitt_z = summeZ / counterZ;
  Serial.println ("EntfernungZ");
  Serial.println (durchschnitt_z);

  // in die Mitte bewegen
  stepperWaagerecht.setSpeed(100);
  stepperWaagerecht.step(-3200); // Anzahl der Schritte die es zur Mitte braucht

  //Sensor nach Oben bewegen
  int counterY = 0;
  float summeY = 0;
  for ( double y = 0; y <= 2040; y += 1) {

    stepperSenkrecht.step(+1); // nur ein Schritt nach oben
    stepperSenkrecht.setSpeed(100);

    //Messung aufnehmen
    digitalWrite(TRIG_PIN, LOW);
    delayMicroseconds(2);
    digitalWrite(TRIG_PIN, HIGH);
    delayMicroseconds(10);
    digitalWrite(TRIG_PIN, LOW);
    long dauer = pulseIn(ECHO_PIN, HIGH);
    float entfernung;
    entfernung = dauer / 29.00 / 2.00;


    // Wenn Entfernung größer als 20, dann ist das Objekt zuende, keine weitere Messaufnahme
    if (entfernung <= 20) {
      summeY = summeY + entfernung;
      counterY++;
      yWert = counterY;

    }

    // Pro Motorschritt ein Millimeter, wird aufsummiert und ergibt ungefähr die Höhe
    else {


      break;
    }

  }

  //Umrechnen der Werte:
  float breiteX = (20 - durchschnitt_x) * 2;
  float laengeZ = (20 - durchschnitt_z) * 2;
  float hoeheY =  (yWert / 100.0); // Umrechnung in cm
  Serial.print(breiteX);
  Serial.print(",");
  Serial.print(hoeheY);
  Serial.print(",");
  Serial.print(laengeZ);
  Serial.print(";");


}


void loop () {} //nicht benötigte Funktion, der Roboter soll nicht unendlich lange messen
